<?php
namespace Teknisa\CRM\Controller;

use Teknisa\CRM\Controller\TeknisaCrud;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource;
use Teknisa\Model\Util\NovoCodigo;
use Zeedhi\Framework\Util\Functions;

class crm00042000ConcorrenteController extends TeknisaCrud
{
    protected $dataSourceName = 'crm_concorrente';
    
    public function __construct ($crudService, $parameterBag, $environment){
        $this->environment   = $environment;

        parent::__construct($crudService, $parameterBag);
    }
    
    
    public function save(Request $request, Response $response) {
        
         try {
            if(method_exists($request, 'getRow')){
                $row = $request->getRow();
            }else{
                $row = $request->getDataSet()->getRows()[0];
            }
            if (\Zeedhi\Framework\Util\Functions::arrayKeyExists('NRCONCORRENTE', $row)) {
                if ($row['__is_new']) {
                    $row['NRCONCORRENTE'] = NovoCodigo::geraCodigo($this->environment->getNrorgTrab(), "NRCONCORRENTE", 1, 10, false, true);
                }
            } else {
                $row['NRCONCORRENTE'] = NovoCodigo::geraCodigo($this->environment->getNrorgTrab(), "NRCONCORRENTE", 1, 10, false, true);
            }
            /*Usa datasource simples no fieldonadd*/
            if(!empty($row['FIELDONADD']))
                $this->dataSourceName = 'crm_concorrente_set';
            parent::save($request, $response);
            
        } catch(\Exception $e) {
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
	    
    }
}
?>