<?php

namespace Teknisa\CRM\Service;

class crm30000000CompromissoService {
    
    protected $planoOcupacaoFactory;
    
    public function __construct($planoOcupacaoFactory) {
        
        $this->planoOcupacaoFactory = $planoOcupacaoFactory;
    }
    
    public function executeInsertCommitmentPart($row, $indexPart){
        
        $paramsQuery = array
        (
            "CDOPERADOR"        => $row['CDCOMMITMENTPARTS'][$indexPart],
            "NRSEQPLANOCUPA"    => $row['NRSEQPLANOCUPA'],
            "NRORG"             => $row['NRORG'],
            "CDINTEPLANOCUPA"   => $row['CDINTEPLANOCUPA'],
            "NRORGINCLUSAO"     => $row['NRORG'],    
            "CDOPERINCLUSAO"    => $row['CDOPERADORESPONS']
        );
        
        $this->planoOcupacaoFactory->queryInsertCommitmentPart($paramsQuery);
    }
    
    public function executeSelectNrseqplanocupa($row){
        $paramsQuery = array
        (
            "DTINIPLANOCUPA"     => $row['DTINIPLANOCUPA']
        );

        
        $nrseqPlanocupa = $this->planoOcupacaoFactory->queryGetNrseqplanocupa($paramsQuery);
        return $nrseqPlanocupa[0];
    }
    
    public function executeSelectCommitmentParts($row){
        $paramsQuery = array
        (
            "NRSEQPLANOCUPA"     => (string)$row['NRSEQPLANOCUPA']
        );

        
        $commitmentParts = $this->planoOcupacaoFactory->queryGetCommitmentParts($paramsQuery);
        return $commitmentParts;
    }
    
    public function queryGetCommitmentInterlocs($row){
        $nrorg = $row['NRORGTRAB'];
        $nrparcnegocio = (string)$row['NRPARCNEGOCIOCOMP'];
        
        $commitmentParts = $this->planoOcupacaoFactory->queryGetCommitmentInterlocs($nrorg, $nrparcnegocio);
        
        foreach($commitmentParts as &$part) {
            $part['TIPO'] = 'INTERLOCUTOR';
        }

        return $commitmentParts;
    }
    
    public function getInterlocs($nrorg, $row) {
        
        if(!empty($row['NRSEQINTERLOC'])) {
            $nrSeqInterlocs = implode(",", $row['NRSEQINTERLOC']);
    
            $commitmentParts = $this->planoOcupacaoFactory->getInterlocs($nrorg, $nrSeqInterlocs);
            
            foreach($commitmentParts as &$interloc) {
                $interloc['TIPO'] = 'INTERLOCUTOR';
            }
            
            return $commitmentParts;
        } else {
            return array();
        }

    }
    
    public function executeUpdateStatusPlanoca($row){
        $paramsQuery = array
        (
            "IDSTATPLANOCUPA"       => $row['IDSTATPLANOCUPA'],
            "NRSEQPLANOCUPA"        => $row['NRSEQPLANOCUPA'],
            "NRORG"                 => $row['NRORG']
        );
        
        $this->planoOcupacaoFactory->queryUpdateStatusPlanocupa($paramsQuery);
    }
    
    public function executeDeleteCommitmentParts($row){
        
        $paramsQuery = array
        (
            "NRSEQPLANOCUPA"        => $row['NRSEQPLANOCUPA'],
            "NRORG"                 => $row['NRORG']
        );
        
        $this->planoOcupacaoFactory->queryDeleteCommitmentParts($paramsQuery);
    }
    
    public function executeDeleteCommitment($row){
        
        $paramsQuery = array
        (
            "NRSEQPLANOCUPA"        => $row['NRSEQPLANOCUPA'],
            "NRORG"                 => $row['NRORG']
        );
        
        $this->planoOcupacaoFactory->queryDeleteCommitment($paramsQuery);
    }
    
    public function getOperador($cdoperador, $nrorg) {
        $paramsQuery = array (
            "CDOPERADOR"  => $cdoperador,
            "NRORG"       => $nrorg
        );
        
        return $this->planoOcupacaoFactory->getOperadores($paramsQuery);
    }
    
}